<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>StructuredLoggers.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">StructuredLoggers.java</span></div><h1>StructuredLoggers.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import java.util.function.Supplier;

<span class="nc" id="L25">public final class StructuredLoggers {</span>

<span class="fc" id="L27">    public static Supplier&lt;Format&gt; JSON = JsonFormat::new;</span>

<span class="fc" id="L29">    private static final class JsonFormat implements Format {</span>

        private static final String QUOTE = &quot;\&quot;&quot;;
        private static final String COLON = &quot;:&quot;;
        private static final String DELIMITER = &quot;, &quot;;
        private static final String PLACE_HOLDER = &quot;{}&quot;;

<span class="fc" id="L36">        private final StringBuilder builder = new StringBuilder(&quot;{&quot;);</span>
<span class="fc" id="L37">        private boolean isFirst = true;</span>

        public &lt;T&gt; JsonFormat bind(String key, Class&lt;T&gt; clazz) {
<span class="fc bfc" id="L40" title="All 2 branches covered.">            if (isFirst) {</span>
<span class="fc" id="L41">                isFirst = false;</span>
            } else {
<span class="fc" id="L43">                builder.append(DELIMITER);</span>
            }
<span class="fc" id="L45">            builder.append(QUOTE).append(key).append(QUOTE).append(COLON);</span>
<span class="fc bfc" id="L46" title="All 2 branches covered.">            if (clazz.equals(String.class)) {</span>
<span class="fc" id="L47">                builder.append(QUOTE).append(PLACE_HOLDER).append(QUOTE);</span>
            } else {
<span class="fc" id="L49">                builder.append(PLACE_HOLDER);</span>
            }
<span class="fc" id="L51">            return this;</span>
        }

        public String build() {
<span class="fc" id="L55">            return builder.append(&quot;}&quot;).toString();</span>
        }

    }

    public interface Format {
        &lt;T&gt; Format bind(String key, Class&lt;T&gt; clazz);
        String build();
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>